/**
 * Container Instance API
 * A description of the Container Instance API
 * OpenAPI spec version: 20210415
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The size and amount of resources available to the Container.
 *
 */
export interface CreateContainerResourceConfigDetails {
    /**
     * The maximum amount of CPU utilization which may be consumed by the Container's process.
     * If no value is provided, then the process may consume all CPU resources on the Instance.
     * CPU usage is defined in terms of logical CPUs. This means that the maximum possible value on
     * an E3 ContainerInstance with 1 OCPU is 2.0.
     * A Container with that vcpusLimit could consume up to 100% of the CPU resources available on the Instance.
     * Values may be fractional. A value of \"1.5\" means that the Container
     * may consume at most the equivalent of 1 and a half logical CPUs worth of CPU capacity
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "vcpusLimit"?: number;
    /**
     * The maximum amount of memory which may be consumed by the Container's process.
     * If no value is provided, then the process may use all available memory on the Instance.
     *  Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "memoryLimitInGBs"?: number;
}
export declare namespace CreateContainerResourceConfigDetails {
    function getJsonObj(obj: CreateContainerResourceConfigDetails): object;
    function getDeserializedJsonObj(obj: CreateContainerResourceConfigDetails): object;
}
