/**
 * Data Connectivity Management API
 * Use the Data Connectivity Management Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Input to perform connector validation. Defines the data integration semantics in a data flow. It can be about reading, writing, or transforming the data.
 */
export interface CreateConnectivityValidationDetails {
    /**
     * The key of the object.
     */
    "key"?: string;
    /**
     * The model version of an object.
     */
    "modelVersion"?: string;
    "parentRef"?: model.ParentReference;
    /**
     * Free form text without any restriction on the permitted characters. Name can have letters, numbers, and special characters. The value is editable and is restricted to 1000 characters.
     */
    "name"?: string;
    /**
     * Details about the operator.
     */
    "description"?: string;
    /**
     * The version of the object that is used to track changes in the object instance. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "objectVersion"?: number;
    /**
     * An array of input ports.
     */
    "inputPorts"?: Array<model.InputPort>;
    /**
     * An array of output ports.
     */
    "outputPorts"?: Array<model.OutputPort>;
    /**
     * The status of an object that can be set to value 1 for shallow references across objects, other values reserved. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "objectStatus"?: number;
    /**
     * Value can only contain upper case letters, underscore, and numbers. It should begin with an upper case letter or underscore. The value can be modified.
     */
    "identifier"?: string;
    /**
     * An array of parameters used in the data flow.
     */
    "parameters"?: Array<model.Parameter>;
    "opConfigValues"?: model.ConfigValues;
    "modelType": string;
}
export declare namespace CreateConnectivityValidationDetails {
    function getJsonObj(obj: CreateConnectivityValidationDetails): object;
    function getDeserializedJsonObj(obj: CreateConnectivityValidationDetails): object;
}
