/**
 * Data Connectivity Management API
 * Use the Data Connectivity Management Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The data preview response.
 */
export interface DataPreview {
    /**
     * Name of the entity for which data preview is requested.
     */
    "entityName": string;
    /**
     * Total number of rows taken for sampling. Note: Numbers greater than Number.MAX_SAFE_INTEGER will result in rounding issues.
     */
    "sampleRowsCount"?: number;
    /**
     * Array of column definition for the preview result.
     */
    "columns"?: Array<model.Column>;
    /**
     * Array of row values for the preview result.
     */
    "rows"?: Array<model.Row>;
}
export declare namespace DataPreview {
    function getJsonObj(obj: DataPreview): object;
    function getDeserializedJsonObj(obj: DataPreview): object;
}
