/**
 * Data Connectivity Management API
 * Use the Data Connectivity Management Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The network validation status for a Private Endpoint - Data Asset pair.
 */
export interface NetworkConnectivityStatus {
    /**
     * DataAsset key to which the NetworkValidationStatus belongs to.
     */
    "dataAssetKey": string;
    /**
     * PrivateEndpoint key, if any, to which the NetworkValidationStatus belongs to.
     */
    "privateEndPointKey"?: string;
    /**
     * Exception or error message encountered while testing network reachability for the data asset.
     */
    "errorMessage"?: string;
    /**
     * The timestamp when the network validation was last updated for the given DataAsset-PrivateEndpoint pair.
     */
    "timeLastUpdated"?: Date;
    /**
     * Exception or error message encountered while testing network reachability for the data asset.
     */
    "networkValidationStatusEnum"?: NetworkConnectivityStatus.NetworkValidationStatusEnum;
}
export declare namespace NetworkConnectivityStatus {
    enum NetworkValidationStatusEnum {
        Reachable = "REACHABLE",
        NotReachable = "NOT_REACHABLE",
        Error = "ERROR",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: NetworkConnectivityStatus): object;
    function getDeserializedJsonObj(obj: NetworkConnectivityStatus): object;
}
