/**
 * Data Connectivity Management API
 * Use the Data Connectivity Management Service APIs to perform common extract, load, and transform (ETL) tasks.
 * OpenAPI spec version: 20210217
 * Contact: di_dcms_dev_ww_grp@oracle.com
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * The list of work request log summaries.
 */
export interface WorkRequestErrorSummary {
    /**
     * A machine-usable code for the error that occured. Error codes are listed in
     * (https://docs.us-phoenix-1.oraclecloud.com/Content/API/References/apierrors.htm).
     *
     */
    "code": string;
    /**
     * A human readable description of the issue encountered.
     */
    "message": string;
    /**
     * The time the error occured. An RFC3339 formatted datetime string.
     */
    "timestamp": Date;
}
export declare namespace WorkRequestErrorSummary {
    function getJsonObj(obj: WorkRequestErrorSummary): object;
    function getDeserializedJsonObj(obj: WorkRequestErrorSummary): object;
}
