/**
 * Java Management Service API
 * API for the Java Management Service. Use this API to view, create, and manage Fleets.
 * OpenAPI spec version: 20210610
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2023, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * Advanced feature metadata for the fleet
 */
export interface FleetAdvancedFeatureConfiguration {
    /**
     * Namespace for the fleet advanced feature
     */
    "analyticNamespace": string;
    /**
     * Bucket name required to store jfr and related data
     */
    "analyticBucketName": string;
    "lcm": model.Lcm;
    "cryptoEventAnalysis": model.CryptoEventAnalysis;
    "advancedUsageTracking": model.AdvancedUsageTracking;
    "jfrRecording": model.JfrRecording;
    /**
     * The date and time of the last modification to the Fleet Agent Configuration (formatted according to [RFC3339](https://datatracker.ietf.org/doc/html/rfc3339)).
     *
     */
    "timeLastModified": Date;
}
export declare namespace FleetAdvancedFeatureConfiguration {
    function getJsonObj(obj: FleetAdvancedFeatureConfiguration): object;
    function getDeserializedJsonObj(obj: FleetAdvancedFeatureConfiguration): object;
}
